ANARC09A - Seinfeld


I’m out of stories. For years I’ve been writing stories, some rather silly, just to make simple problems look difficult and complex problems look easy. But, alas, not for this one.

You’re given a non empty string made in its entirety from opening and closing braces. Your task is to find the minimum number of “operations” needed to make the string stable. The definition for being stable is as follows:

  1. An empty string is stable.
  2. If S is stable, then {S} is also stable.
  3. If S and T are both stable, then ST (the concatenation of the two) is also stable.

All of these strings are stable: {}, {}{}, and {{}{}}; But none of these: }{, {{}{, nor {}{.
The only operation allowed on the string is to replace an opening brace with a closing brace, or vice-versa.

Input

Your program will be tested on one or more data sets. Each data set is described on a single line. The line is a non-empty string of opening and closing braces and nothing else. No string has more than 2000 braces. All sequences are of even length.

The last line of the input is made of one or more ’-’ (minus signs.)

Output

For each test case, print the following line:

k. N

Where k is the test case number (starting at one,) and N is the minimum number of operations needed to convert the given string into a balanced one.

Example

Input:
}{
{}{}{}
{{{}
---

Output: 1. 2
2. 0
3. 1

hide comments
parikhparth: 2019-05-09 10:47:17

For people coding in Python remember to do rstrip() on your input. The input parameter is vague!

hetp111: 2019-04-30 20:20:18

dp not needed.

sagar_june97p: 2019-04-30 17:07:30

DP solution passed after 3 WA. BTW use scanf instead of getline or cin. Also declare the dp array as global.

Last edit: 2019-04-30 17:08:32
ramini1996: 2019-04-10 19:25:18

No need of DP at all...!!!

gaurav__404: 2019-03-23 16:54:51

Again ... why is it tagged DP ( might be due to ............ )

tarungupta: 2019-03-11 17:36:58

AC in 1 go. Stack implementation.

sabbirh654: 2019-01-20 11:56:57

it's not a contest platform.if you can solve without stack,try it with satck.it will boost up your skills and ideas.
though no dp is necessary,if you solve it using dp that may help you in future.who knows? :)

shubham: 2019-01-15 16:19:19

It did require some analysis to solve using stack. Observing the final unbalanced string must be of the form }}}... {{{.. which is closed followed by opens.
Min operations will be [open / 2 + closed / 2 + (2 * (open % 2))]

vcode11: 2019-01-05 07:51:35

I got a score for this problem what does iit mean?

ducluong: 2018-10-27 15:21:02

obviously stack is enough to solve this problem, but can you give me some advise to solve this in dp


Added by:Mohammad Kotb
Date:2009-11-28
Time limit:3.236s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All except: ASM64 BASH JS-RHINO
Resource:http://www.icpc-anarc.org